//---------------------------------------------------------------------------
//
//   CrossPoint
//
//          Copyright(C) 2013, Tark
//
//     ӂ̍ŋߓ_ɒ_ǉ
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "MQPlugin.h"
#include "MQBasePlugin.h"
#include "CMQObject.h"
#include "CrossPoint.h"

//---------------------------------------------------------------------------
//  MQGetPlugInID
//---------------------------------------------------------------------------
void CrossPoint::GetPlugInID(DWORD *Product, DWORD *ID)
{
	*Product = 0xE3F7A830;
	*ID      = 0xBD9A1872;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//---------------------------------------------------------------------------
const char *CrossPoint::GetPlugInName(void)
{
	// vOC
	return "CrossPoint ver.1.0 Copyright(C) 2013, Tark.";
}

//---------------------------------------------------------------------------
//  MQEnumString
//---------------------------------------------------------------------------
const char *CrossPoint::EnumString(int index)
{
	switch(index){
	case 0: return "CrossPoint"; break;
	}
	return NULL;
}

MQBasePlugin *GetPluginClass()
{
	static CrossPoint plugin;
	return &plugin;
}

BOOL CrossPoint::Execute(int index, MQDocument doc_)
{
	switch(index){
	case 0:
		{
			doc = cmq::CMQDocument(doc_);
			obj = doc.getCurrentObject();
			return main();
		}
	}
	return FALSE;
}

const float CrossPoint::delta = 0.0001f;

CrossPoint::CrossPoint() : doc(nullptr)
{
}

CrossPoint::~CrossPoint()
{
}

BOOL CrossPoint::main()
{
	// I
	auto selectedline = getSelectedLine();
	if(selectedline.size() != 2) {
		// 2ӑIłȂ

		return FALSE;
	}

	// ŋߓ_߂
	std::vector<std::pair<MQPoint, float>> ppair;
	BOOL ret = getNearPoint(selectedline[0], selectedline[1], ppair);
	if(!ret) {
		return FALSE;
	}

	MQPoint &p1 = ppair[0].first;
	MQPoint &p2 = ppair[1].first;
	if((p1 - p2).norm() < delta) {
		p2 = p1;
	}

	// ŋߓ_Ŗʂ𕪊
	return separateFaces(selectedline[0], selectedline[1], ppair[0], ppair[1]);
	return TRUE;
}

std::vector<std::pair<cmq::findex_t, int>> CrossPoint::getSelectedLine()
{
	std::vector<std::pair<cmq::findex_t, int>> selectedline;
	std::vector<cmq::lindex_t> selectedlinevert;
	cmq::CMQContainer<cmq::CMQFace, cmq::CMQObject> fcontainer(&obj);
	for(auto fit = fcontainer.begin(); fit != fcontainer.end(); ++fit) {
		auto varray = fit->getFacePointArray();
		for(int lindex = 0; lindex < varray.size(); lindex++) {
			if(doc.isSelectLine(obj, fit.index(), lindex)) {
				cmq::lindex_t lid = cmq::makeLineId(varray[lindex], varray[(lindex + 1) % varray.size()]);
				if(std::find(selectedlinevert.begin(), selectedlinevert.end(), lid) != selectedlinevert.end()) {
					// }ς
					continue;
				}
				selectedline.push_back(std::make_pair(fit.index(), lindex));
				selectedlinevert.push_back(lid);
				break;
			}
		}
	}
	return selectedline;
}

BOOL CrossPoint::getNearPoint(std::pair<cmq::findex_t, int> &line1, std::pair<cmq::findex_t, int> &line2, 
							  std::vector<std::pair<MQPoint, float>> &ppair)
{
	auto v1pair = obj.getLineVertex(line1.first, line1.second);
	auto v2pair = obj.getLineVertex(line2.first, line2.second);
	MQPoint v1_1 = obj.getVertex(v1pair.first);
	MQPoint v1_2 = obj.getVertex(v1pair.second);
	MQPoint v2_1 = obj.getVertex(v2pair.first);
	MQPoint v2_2 = obj.getVertex(v2pair.second);
	MQPoint vec1 = v1_2 - v1_1;
	MQPoint vec2 = v2_2 - v2_1;
	vec1.normalize();
	vec2.normalize();
	MQPoint vec0 = v2_1 - v1_1;
	float i01 = cmq::CMQPoint::innercross(vec0, vec1);
	float i02 = cmq::CMQPoint::innercross(vec0, vec2);
	float i12 = cmq::CMQPoint::innercross(vec1, vec2);
	float d = 1.0f - i12 * i12;
	if(d == 0) {
		return FALSE;
	}
	float d1 = (i01 - i12 * i02) / d;
	float d2 = (i12 * i01 - i02) / d;
	float v1len = (v1_2 - v1_1).abs();
	float v2len = (v2_2 - v2_1).abs();
	if(d1 <= delta || v1len - d1 <= delta) {
		return FALSE;
	}
	if(d2 <= delta || v2len - d2 <= delta) {
		return FALSE;
	}
	float dp1 = d1 / v1len;
	float dp2 = d2 / v2len;

	MQPoint p1 = v1_1 + vec1 * d1;
	MQPoint p2 = v2_1 + vec2 * d2;
	ppair.push_back(std::make_pair(p1, dp1));
	ppair.push_back(std::make_pair(p2, dp2));
return TRUE;
}

BOOL CrossPoint::separateFaces(std::pair<cmq::findex_t, int> &line1, std::pair<cmq::findex_t, int> &line2,
							   std::pair<MQPoint, float> &ppair1, std::pair<MQPoint, float> &ppair2)
{
	auto v1pair = obj.getLineVertex(line1.first, line1.second);
	auto v2pair = obj.getLineVertex(line2.first, line2.second);
	cmq::vindex_t v1 = obj.addVertex(ppair1.first);
	cmq::vindex_t v2 = (ppair1.first == ppair2.first) ? v1 : obj.addVertex(ppair2.first);
	obj.addSelectVertex(v1);
	obj.addSelectVertex(v2);
	auto larray = obj.getOtherLine(v1pair.first, v1pair.second);
	for(auto flpair : larray) {
		cmq::findex_t findex = flpair.first;
		int lindex = flpair.second;
		addVertex2Face(findex, lindex, v1, ppair1.second);
	}
	larray = obj.getOtherLine(v2pair.first, v2pair.second);
	for(auto flpair : larray) {
		cmq::findex_t findex = flpair.first;
		int lindex = flpair.second;
		addVertex2Face(findex, lindex, v2, ppair2.second);
	}
	return TRUE;
}

BOOL CrossPoint::addVertex2Face(cmq::findex_t findex, int lindex, int v1, float dp)
{
	auto varray = obj.getFacePointArray(findex);
	if(varray.size() == 2) {
		return separateLine(findex, lindex, v1, dp);
	}
	varray.insert(varray.begin() + lindex + 1, v1);
	int newindex = obj.addFace(varray);
	obj.setFaceVisible(newindex, obj.getFaceVisible(findex));
	obj.setFaceMaterial(newindex, obj.getFaceMaterial(findex));
	// UV
	auto carray = obj.getFaceCoordinateArray(findex);
	MQCoordinate u1;
	MQCoordinate u2;
	if(lindex == carray.size() - 1) {
		u1 = carray.back().getCoordinate();
		u2 = carray.front().getCoordinate();
	}
	else {
		u1 = carray[lindex].getCoordinate();
		u2 = carray[lindex + 1].getCoordinate();
	}
	cmq::CMQCoordinate cood = cmq::CMQCoordinate(v1, u1 + (u2 - u1) * dp);
	carray.insert(carray.begin() + lindex + 1, cood);
	obj.setFaceCoordinateArray(newindex, carray);
	// _J[Asx
	DWORD vcol;
	float vedge;
	for(int i = 0; i < lindex + 1; i++) {
		vcol = obj.getFaceVertexColor(findex, i);
		vedge = obj.getFaceEdgeCrease(findex, i);
		obj.setFaceVertexColor(newindex, i, vcol);
		obj.setFaceEdgeCrease(newindex, i, vedge);
	}
	DWORD vcol1 = obj.getFaceVertexColor(findex, lindex);
	DWORD vcol2 = obj.getFaceVertexColor(findex, lindex + 1);
	DWORD vcol0 = vcol1 + (vcol2 - vcol1) * dp;
	obj.setFaceVertexColor(newindex, lindex + 1, vcol0);
	float vedge1 = obj.getFaceEdgeCrease(findex, lindex);
	float vedge2 = obj.getFaceEdgeCrease(findex, lindex + 1);
	float vedge0 = vedge1 + (vedge2 - vedge1) * dp;
	obj.setFaceEdgeCrease(newindex, lindex + 1, vedge0);
	for(int i = lindex + 2; i < varray.size(); i++) {
		vcol = obj.getFaceVertexColor(findex, i - 1);
		vedge = obj.getFaceEdgeCrease(findex, i - 1);
		obj.setFaceVertexColor(newindex, i, vcol);
		obj.setFaceEdgeCrease(newindex, i, vedge);
	}
	obj.deleteFace(findex);
	return newindex;
}

BOOL CrossPoint::separateLine(cmq::findex_t findex, int lindex, int v1, float dp)
{
	auto varray = obj.getFacePointArray(findex);
	std::vector<cmq::vindex_t> varray1;
	std::vector<cmq::vindex_t> varray2;
	varray1.push_back(varray[0]);
	varray1.push_back(v1);
	varray2.push_back(v1);
	varray2.push_back(varray[1]);
	int f1 = obj.addFace(varray1);
	int f2 = obj.addFace(varray2);
	obj.setFaceVisible(f1, obj.getFaceVisible(findex));
	obj.setFaceMaterial(f1, obj.getFaceMaterial(findex));
	obj.setFaceVisible(f2, obj.getFaceVisible(findex));
	obj.setFaceMaterial(f2, obj.getFaceMaterial(findex));
	// UV
	auto carray = obj.getFaceCoordinateArray(findex);
	std::vector<cmq::CMQCoordinate> carray1;
	std::vector<cmq::CMQCoordinate> carray2;
	MQCoordinate u1 = carray.back().getCoordinate();
	MQCoordinate u2 = carray.front().getCoordinate();
	cmq::CMQCoordinate cood = cmq::CMQCoordinate(v1, u1 + (u2 - u1) * dp);
	carray1.push_back(carray[0]);
	carray1.push_back(cood);
	carray2.push_back(cood);
	carray2.push_back(carray[1]);
	obj.setFaceCoordinateArray(f1, carray1);
	obj.setFaceCoordinateArray(f2, carray2);
	// _J[
	DWORD vcol1 = obj.getFaceVertexColor(findex, 0);
	DWORD vcol2 = obj.getFaceVertexColor(findex, 1);
	DWORD vcol0 = vcol1 + (vcol2 - vcol1) * dp;
	obj.setFaceVertexColor(f1, 0, vcol1);
	obj.setFaceVertexColor(f1, 1, vcol0);
	obj.setFaceVertexColor(f2, 0, vcol0);
	obj.setFaceVertexColor(f2, 1, vcol2);
	// sx
	float vedge1 = obj.getFaceEdgeCrease(findex, 0);
	float vedge2 = obj.getFaceEdgeCrease(findex, 1);
	float vedge0 = vedge1 + (vedge2 - vedge1) * dp;
	obj.setFaceEdgeCrease(f1, 0, vedge1);
	obj.setFaceEdgeCrease(f1, 1, vedge0);
	obj.setFaceEdgeCrease(f2, 0, vedge0);
	obj.setFaceEdgeCrease(f2, 1, vedge2);
	obj.deleteFace(findex);
	return TRUE;
}